;	NETWORK DISK OPERATING SYSTEM FOR CP/NET on CP/M Plus v3
;
;	Initialization module - RSX prefix
;
;	EQUATIONS OF DATA
;
LF	EQU	0AH	;LINE FEED
CR	EQU	0DH	;CARRIAGE RETURN

;
;	EQUATIONS OF DOS FUNCTION
;
CBUFPR	EQU	9	;BUFFER PRINT
COVLY	equ	59	; load overlay
CRSX	equ	60	; call RSX function

	public	NXBDOS, RSXNAM, IOPORT

	; from NDOSx
	extrn	NDINIT, NDWARM, NDOSE

	cseg

;	RSX Prefix
serial:	db	0,0,0,0,0,0
start:	jmp	COLDST
NXBDOS:	jmp	0
prev:	dw	0
remove:	db	0	; 0ffh for remove
nonbank:
	db	0
RSXNAM:	db	'NDOS3   '
loader:	db	0,0,0

IOPORT:	db	018h	; could be patched here

CSTUP:	DB	'NDOS3 Started',CR,LF,'$'
CSTDN:	DB	'NDOS3 Ending',CR,LF,'$'
;wbmsg:	DB	'NDOS3 Warm-boot',CR,LF,'$'
CLDERR:	db	'NDOS3 Init err',CR,LF,'$'

COLDSE:
	lxi	d,CLDERR
	mvi	c,CBUFPR
	call	NXBDOS
	lxi	h,NXBDOS
	shld	start+1	; only until remove takes place...
	mvi	a,0ffh
	sta	remove
	pop	b
	pop	d
	jmp	NXBDOS	; pass to BDOS and hope for the best...

; Not a true cold start - we are in context of a valid BDOS call...
COLDST:
	push	d
	push	b
	lxi	h,BDOSE
	shld	start+1
	xra	a	;
	sta	remove	; is the required?
	call	NDINIT
	; if this returns NZ, we have an error...
	jnz	COLDSE
	pop	b
	pop	d
BDOSE:
	mov	a,c
	ora	a
	jz	WARMST
	cpi	COVLY
	jz	LDOVLY	; LOAD OVERLAY (RSX SCRUB) - indication of warm boot
	cpi	CRSX	; used to unload CP/Net RSX
	jnz	NDOSE
; An example of how to process BDOS Func 60 RSX Func 113
; and remove one's self.
CALRSX:
	mov	l,e
	mov	h,d
	mov	a,m
	inx	h
	cpi	113	; Check for RSX Func 113
	jnz	NXBDOS
	mov	a,m
	inx	h
	cpi	1	; Check param count to be sure
	jnz	NXBDOS
	push	d
	mov	e,m
	inx	h
	mov	d,m
	lxi	h,rsxnam
	mvi	b,8
rsxf0:			; Compare paramter to our name
	ldax	d
	cmp	m
	jnz	rsxf1
	inx	d
	inx	h
	dcr	b
	jnz	rsxf0
rsxf1:
	pop	d
	jnz	NXBDOS
	lxi	d,CSTDN
	mvi	c,CBUFPR
	call	NXBDOS
	lxi	h,NXBDOS
	shld	start+1	; only until remove takes place...
	mvi	a,0ffh
	sta	remove
	lxi	h,0
	mov	a,l
	ret

; this is used to do warm boot initialization, since most
; programs do not call BDOS Function 0 but instead just
; JMP 0. The CCP then makes this call, either upon startup
; and/or immediately prior to running a program.
; Perportedly, the CPP calls this with DE=NULL in order
; to scrub RSXs on warm boot.
; Again, this is in the context of a BDOS call and we must
; pass it along no matter what.
LDOVLY:
WARMST:
	push	d
	push	b
	call	NDWARM
	; TODO: any other re-init? reset some context?
;	lxi	d,wbmsg
;	mvi	c,CBUFPR
;	call	NXBDOS
	pop	b
	pop	d
	jmp	NXBDOS

	end
