// Copyright (c) 2011,2016 Douglas Miller

import java.awt.*;
import java.io.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.io.*;

public class FileBox extends JPanel {
	static final long serialVersionUID = 773160000002L;

	JTextField tf;
	JButton butt;
	File file;

	public FileBox(String title, int key, ActionListener them) {
		super();
		file = null;

		GridBagLayout gridbag = new GridBagLayout();
		setLayout(gridbag);
		GridBagConstraints gc = new GridBagConstraints();
		gc.fill = GridBagConstraints.NONE;
		gc.gridx = 0;
		gc.gridy = 0;
		gc.weightx = 0;
		gc.weighty = 0;
		gc.gridwidth = 1;
		gc.gridheight = 1;
		gc.anchor = GridBagConstraints.NORTH;

		JLabel tl = new JLabel(title);
		gc.gridwidth = 2;
		gridbag.setConstraints(tl, gc);
		add(tl);
		++gc.gridy;
		gc.gridx = 0;
		tf = new JTextField(40);
		gc.gridwidth = 1;
		gridbag.setConstraints(tf, gc);
		add(tf);
		butt = new JButton("Browse");
		butt.setMnemonic(key);
		butt.addActionListener(them);
		++gc.gridx;
		gridbag.setConstraints(butt, gc);
		add(butt);
	}

	public String getField() {
		return tf.getText();
	}

	public File getDir() {
		if (file == null || file.getParentFile() == null) {
			return new File(".");
		}
		return file.getParentFile();
	}

	public File getFile() {
		return file;
	}
	public void setFile(File f) {
		file = f;
		tf.setText(f.getName());
//System.err.println("File: " + f.getAbsolutePath());
	}

	public boolean checkFile() {
		if (tf.getText().isEmpty()) {
			file = null;
//System.err.println("File gone");
			return true;
		}
		if (file == null) {
			file = new File(tf.getText());
//System.err.println("File init: " + file.getAbsolutePath());
			return true;
		}
		if (!file.getName().equals(tf.getText())) {
			if (tf.getText().startsWith("/")) {
				file = new File(tf.getText());
			} else {
				file = new File(file.getParentFile() + "/" + tf.getText());
			}
//System.err.println("File changed: " + file.getAbsolutePath());
			return true;
		}
		return false;
	}
}
