// Copyright (c) 2011,2014 Douglas Miller
// $Id: SuffFileChooser.java,v 1.4 2014/01/14 21:53:51 drmiller Exp $

import java.awt.*;
import java.io.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.io.*;

public class FormatOptions extends JFrame implements ActionListener {
	static final long serialVersionUID = 773160000001L;

	FileBox new_fb;
	FileBox fil_fb;
	ButtonGroup den_grp;
	ButtonGroup sid_grp;
	ButtonGroup tpi_grp;
	ButtonGroup fmt_grp;
	ButtonGroup media_grp;
	File _dir;

	public FormatOptions(String title) {
		super(title);
		getContentPane().setName(title);
		//getContentPane().setBackground(Color.black);

		GridBagLayout gridbag = new GridBagLayout();
		setLayout(gridbag);
		int wid = 8; // grid widths total

		GridBagConstraints gc = new GridBagConstraints();
		gc.fill = GridBagConstraints.NONE;
		gc.gridx = 0;
		gc.gridy = 0;
		gc.weightx = 0;
		gc.weighty = 0;
		gc.gridwidth = 1;
		gc.gridheight = 1;
		gc.anchor = GridBagConstraints.NORTH;

		ButtonGroup grp;
		JRadioButton op;

		FileBox fb = new FileBox("New Disk Image", KeyEvent.VK_N, this);
		new_fb = fb;
		gc.gridwidth = wid;
		gridbag.setConstraints(fb, gc);
		add(fb);
		++gc.gridy;
		gc.gridwidth = 1;

		fb = new FileBox("Data Source (optional)", KeyEvent.VK_R, this);
		fil_fb = fb;
		gc.gridwidth = wid;
		gridbag.setConstraints(fb, gc);
		add(fb);
		++gc.gridy;
		gc.gridwidth = 1;

		grp = new ButtonGroup();
		op = new JRadioButton("DD", true);
		op.setText("DD");
		op.setActionCommand("DD");
		grp.add(op);
		gridbag.setConstraints(op, gc);
		add(op);
		op = new JRadioButton("SD", false);
		op.setText("SD");
		op.setActionCommand("SD");
		grp.add(op);
		den_grp = grp;
		gc.gridy += 1;
		gridbag.setConstraints(op, gc);
		gc.gridy -= 1;
		add(op);
		++gc.gridx;

		grp = new ButtonGroup();
		op = new JRadioButton("DS", true);
		op.setText("DS");
		op.setActionCommand("DS");
		grp.add(op);
		gridbag.setConstraints(op, gc);
		add(op);
		op = new JRadioButton("SS", false);
		op.setText("SS");
		op.setActionCommand("SS");
		grp.add(op);
		sid_grp = grp;
		gc.gridy += 1;
		gridbag.setConstraints(op, gc);
		gc.gridy -= 1;
		add(op);
		++gc.gridx;

		grp = new ButtonGroup();
		op = new JRadioButton("DT", false);
		op.setText("DT");
		op.setActionCommand("DT");
		grp.add(op);
		gridbag.setConstraints(op, gc);
		add(op);
		op = new JRadioButton("ST", true);
		op.setText("ST");
		op.setActionCommand("ST");
		grp.add(op);
		tpi_grp = grp;
		gc.gridy += 1;
		gridbag.setConstraints(op, gc);
		gc.gridy -= 1;
		add(op);
		++gc.gridx;

		grp = new ButtonGroup();
		op = new JRadioButton("5.25\"", true);
		op.setText("5.25\"");
		op.setActionCommand("5");
		grp.add(op);
		gridbag.setConstraints(op, gc);
		add(op);
		op = new JRadioButton("8\"", false);
		op.setText("8\"");
		op.setActionCommand("8");
		grp.add(op);
		media_grp = grp;
		gc.gridy += 1;
		gridbag.setConstraints(op, gc);
		gc.gridy -= 1;
		add(op);
		++gc.gridx;

		grp = new ButtonGroup();
		op = new JRadioButton("MMS", true);
		op.setText("MMS");
		op.setActionCommand("MMS");
		grp.add(op);
		gridbag.setConstraints(op, gc);
		add(op);
		op = new JRadioButton("M47", false);
		op.setText("M47");
		op.setActionCommand("M47");
		grp.add(op);
		gc.gridy += 1;
		gridbag.setConstraints(op, gc);
		gc.gridy -= 1;
		add(op);
		++gc.gridx;

		op = new JRadioButton("Z37", false);
		op.setText("Z37");
		op.setActionCommand("Z37");
		grp.add(op);
		gridbag.setConstraints(op, gc);
		add(op);
		op = new JRadioButton("Z37X", false);
		op.setText("Z37X");
		op.setActionCommand("Z37X");
		grp.add(op);
		gc.gridy += 1;
		gridbag.setConstraints(op, gc);
		gc.gridy -= 1;
		add(op);
		++gc.gridx;

		op = new JRadioButton("Z47", false);
		op.setText("Z47");
		op.setActionCommand("Z47");
		grp.add(op);
		gridbag.setConstraints(op, gc);
		add(op);
		op = new JRadioButton("Z47X", false);
		op.setText("Z47X");
		op.setActionCommand("Z47X");
		grp.add(op);
		gc.gridy += 1;
		gridbag.setConstraints(op, gc);
		gc.gridy -= 1;
		add(op);
		++gc.gridx;

		op = new JRadioButton("Z67", false);
		op.setText("Z67");
		op.setActionCommand("Z67");
		grp.add(op);
		gridbag.setConstraints(op, gc);
		++gc.gridx;
		add(op);
		fmt_grp = grp;

		++gc.gridy;
		++gc.gridy;
		gc.gridx = 0;

		JButton butt = new JButton("Format");
		butt.setMnemonic(KeyEvent.VK_F);
		butt.addActionListener(this);
		gc.gridwidth = wid / 2;
		gridbag.setConstraints(butt, gc);
		add(butt);

		butt = new JButton("Quit");
		butt.setMnemonic(KeyEvent.VK_Q);
		butt.addActionListener(this);
		gc.gridx = wid / 2;
		gc.gridwidth = wid - (wid / 2);
		gridbag.setConstraints(butt, gc);
		add(butt);
		++gc.gridy;
	}

	public void format(FormatSpecs fs) {
		// ... build image of one track ...
		FileOutputStream fo;
		try {
			fo = new FileOutputStream(new_fb.getFile());
		} catch (Exception ee) {
			error(this, new_fb.getField(), ee.printStack());
			return;
		}
		// ... format disk ... for each track/side modify image and write...
		try {
			fo.close();
		} catch (Exception ee) {
			error(this, new_fb.getField(), ee.printStack());
			return;
		}
	}

	public void actionPerformed(ActionEvent e) {
		if (!(e.getSource() instanceof JButton)) {
			return;
		}
		JButton butt = (JButton)e.getSource();
		int key = butt.getMnemonic();
		if (key == KeyEvent.VK_Q) {
			System.exit(0);
		}
		if (key == KeyEvent.VK_F) {
System.err.println("Format!");
			FormatSpecs fs = new FormatSpecs(
				fmt_grp.getSelection().getActionCommand(),
				media_grp.getSelection().getActionCommand(),
				den_grp.getSelection().getActionCommand(),
				sid_grp.getSelection().getActionCommand(),
				tpi_grp.getSelection().getActionCommand());
			if (fs.D8 && (fs.DT || fs.Z37 || fs.Z37X || fs.Z67)) {
				error(this, "Format Selection",
					"Format not valid for 8\" diskette");
				return;
			}
			if (!fs.D8 && (fs.M47 || fs.Z47X || fs.Z47)) {
				error(this, "Format Selection",
					"Format not valid for 5.25\" diskette");
				return;
			}
			new_fb.checkFile();
			fil_fb.checkFile();
			if (new_fb.getField().isEmpty()) {
				error(this, "File",
					"No new file given");
				return;
			}
			File newFile = new_fb.getFile();
			if (newFile.exists()) {
				error(this, "File",
					"New file exists - will not overwrite");
				return;
			}
			File filFile = null;
			if (!fil_fb.getField().isEmpty()) {
				filFile = new File(fil_fb.getField());
			}
			if (filFile != null && !filFile.exists()) {
				error(this, "Data File",
					"Image data file does not exist");
				return;
			}
			format(fs);

			return;
		}
		if (key == KeyEvent.VK_N) {
			SuffFileChooser ch = new SuffFileChooser("Create New File",
					new_fb.getDir());
			int rv = ch.showDialog(this);
			if (rv == JFileChooser.APPROVE_OPTION) {
				new_fb.setFile(ch.getSelectedFile());
			}
			return;
		}
		if (key == KeyEvent.VK_R) {
			SuffFileChooser ch = new SuffFileChooser("Use Data from File",
					fil_fb.getDir());
			int rv = ch.showDialog(this);
			if (rv == JFileChooser.APPROVE_OPTION) {
				fil_fb.setFile(ch.getSelectedFile());
			}
			return;
		}
	}

	static public void error(JFrame main, String op, String err) {
		JOptionPane.showMessageDialog(main,
			new JLabel(err),
			op + " Error", JOptionPane.ERROR_MESSAGE);
	}
}
