// Copyright (c) 2016 Douglas Miller <durgadas311@gmail.com>
import java.util.Properties;

public class LegacyH8Ports implements IODevice {
	private Interruptor intr;
	private int base;
	private int num;

	public LegacyH8Ports(Properties props, int base, int num, Interruptor intr) {
		this.intr = intr;
		this.base = base;
		this.num = num;
		reset();
	}

	/// IODevice interface ///

	public void reset() {
	}

	public int getBaseAddress() {
		return base;
	}
	public int getNumPorts() {
		return num;
	}
	public int in(int port) {
		intr.triggerNMI();
		return 0xff;
	}
	public void out(int port, int value) {
		intr.triggerNMI();
	}

	public String getDeviceName() { return null; }

	public String dumpDebug() {
		return "";
	}
}
