// Copyright (c) 2019 Douglas Miller <durgadas311@gmail.com>

import java.util.Arrays;
import java.util.Vector;
import java.util.Properties;

public class MagNetHFB extends HostFileBdos {

	public MagNetHFB(Properties props, String prefix, Vector<String> args,
						int cltId, CpnetServer srv) {
		super(props, prefix, args, cltId, srv);
	}

	private void makeError(byte[] buf, int cd) {
		ServerDispatch.putCode(buf, cd);
		ServerDispatch.putBC(buf, 0);
		ServerDispatch.putDE(buf, 1); // error ?
	}

	private byte[] doMagNet(byte[] msgbuf, int length) {
		int code = ServerDispatch.getCode(msgbuf);
		if (code == 0x30) { // Token - status
			// TODO: merge our own copy...
			int ix = NetworkServer.mpayload + 1 +
				srv.cfgTab.id;
			msgbuf[ix] = (byte)NetworkServer.tfileserver;
			ServerDispatch.putBC(msgbuf, 0x1000 | srv.cfgTab.id);
			return msgbuf;
		} else if (code == 0x20) { // Boot
			// TODO: support MagNet boot?
			makeError(msgbuf, 0x38);
			return msgbuf;
		} else {
			// TODO: this may not be correct...
			makeError(msgbuf, 0x38);
			return msgbuf;
		}
	}

	public byte[] sendMsg(byte[] msgbuf, int len) {
		if (ServerDispatch.getCode(msgbuf) != 0x00) {
			// MAGNet messages
			return doMagNet(msgbuf, len);
		}
		// TODO: extract CP/NET message...
		// rsp = super.sendMsg(buf, len);
		// TODO: package up MagNet response
//		msgbuf[NetworkServer.msize] = (byte)(lr - 1);
//		byte src = msgbuf[NetworkServer.msid];
//		msgbuf[NetworkServer.msid] = msgbuf[NetworkServer.mdid];
//		msgbuf[NetworkServer.mdid] = src;
//		msgbuf[NetworkServer.mcode] |= 1;
//		// fix-up MAGNet header for reply...
//		ServerDispatch.putCode(msgbuf, 0x01);
//		ServerDispatch.putBC(msgbuf, lr + NetworkServer.mhdrlen);
//		ServerDispatch.putDE(msgbuf, 0);
//		ServerDispatch.putHL(msgbuf, 0);
		return msgbuf;
	}

}
